#in
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt=!{SelectedItem:{tag:{}}},predicate=minecraft:in_overworld,tag=!deeper_dark.tp_cooldown] at @s if block ~ ~-.1 ~ minecraft:reinforced_deepslate run tag @s add deeper_dark.tp_in_player
execute as @a[tag=deeper_dark.tp_in_player] at @s run function deeper_dark:save
execute as @a[tag=deeper_dark.tp_in_player] at @s in deeper_dark:deeper_dark run tp @s[tag=deeper_dark.tp_in_player] ~1000 0 ~1000
execute as @a[tag=deeper_dark.tp_in_player] at @s run spreadplayers ~ ~ 0 10 under 63 false @s
execute as @a[tag=deeper_dark.tp_in_player] at @s run fill ~ ~ ~ ~ ~1 ~ minecraft:air destroy
execute as @a[tag=deeper_dark.tp_in_player] at @s run playsound minecraft:entity.warden.sonic_boom ambient @a ~ ~ ~ 1 0
execute as @a[tag=deeper_dark.tp_in_player] at @s run playsound minecraft:block.portal.ambient ambient @a ~ ~ ~ 1 2
execute as @a[tag=deeper_dark.tp_in_player] at @s run playsound minecraft:block.sculk_shrieker.shriek ambient @a ~ ~ ~ 1 0
execute as @a[tag=deeper_dark.tp_in_player] at @s run playsound minecraft:block.respawn_anchor.set_spawn ambient @a ~ ~ ~ 1 0
execute as @a[tag=deeper_dark.tp_in_player] at @s run playsound minecraft:block.enchantment_table.use ambient @a ~ ~ ~ 1 2
execute as @a[tag=deeper_dark.tp_in_player] at @s run effect give @s minecraft:blindness 5 0 true
execute as @a[tag=deeper_dark.tp_in_player] at @s run effect give @s minecraft:slow_falling 1000000 238 true
execute as @a[tag=deeper_dark.tp_in_player] at @s unless block ~ ~-.1 ~ minecraft:reinforced_deepslate run tag @s remove deeper_dark.tp_in_player

#out
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt={SelectedItem:{tag:{DeeperDarkKey:1b}}},predicate=deeper_dark:in_deeper_dark,tag=!deeper_dark.tp_cooldown] at @s if block ~ ~-.1 ~ minecraft:reinforced_deepslate run tag @s add deeper_dark.tp_out_player
execute as @a[tag=deeper_dark.tp_out_player] at @s in minecraft:overworld run tp @s ~ 10000 ~
execute as @a[tag=deeper_dark.tp_out_player] at @s in minecraft:overworld run effect give @s minecraft:slow_falling 1 0 true
execute as @a[tag=deeper_dark.tp_out_player] at @s run summon minecraft:armor_stand ~ ~ ~ {Marker:1b,Invisible:1b,Tags:["deeper_dark.tp_out"]}
execute as @a[tag=deeper_dark.tp_out_player] at @s run item replace entity @e[tag=deeper_dark.tp_out,limit=1,sort=nearest] weapon.mainhand from entity @s weapon.mainhand
execute as @e[tag=deeper_dark.tp_out,limit=1,sort=nearest] at @s run function deeper_dark:tp_out

#cooldown
execute as @a[tag=deeper_dark.tp_cooldown] at @s unless block ~ ~-.1 ~ minecraft:reinforced_deepslate run tag @s remove deeper_dark.tp_cooldown
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},tag=deeper_dark.tp_in_player] at @s run tag @s add deeper_dark.tp_cooldown
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},tag=deeper_dark.tp_out_player] at @s run tag @s add deeper_dark.tp_cooldown

#particle
scoreboard objectives add deeper_dark.near_portal dummy
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt=!{SelectedItem:{tag:{}}},predicate=minecraft:in_overworld,tag=!deeper_dark.tp_cooldown] at @s store success score @s deeper_dark.near_portal run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 chain_command_block{Command:"deeper_dark.near_portal"} replace reinforced_deepslate
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt=!{SelectedItem:{tag:{}}},predicate=minecraft:in_overworld,tag=!deeper_dark.tp_cooldown] at @s run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 reinforced_deepslate replace chain_command_block{Command:"deeper_dark.near_portal"}
execute at @a[scores={deeper_dark.near_portal=1}] run particle minecraft:sculk_soul ~ ~ ~ 2 2 2 0 5 force
execute at @a[scores={deeper_dark.near_portal=1}] run playsound minecraft:block.sculk_catalyst.bloom ambient @a ~ ~ ~ .75 0

execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt={SelectedItem:{tag:{DeeperDarkKey:1b}}},predicate=deeper_dark:in_deeper_dark,tag=!deeper_dark.tp_cooldown] at @s store success score @s deeper_dark.near_portal run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 chain_command_block{Command:"deeper_dark.near_portal"} replace reinforced_deepslate
execute as @a[nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b}},nbt={SelectedItem:{tag:{DeeperDarkKey:1b}}},predicate=deeper_dark:in_deeper_dark,tag=!deeper_dark.tp_cooldown] at @s run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 reinforced_deepslate replace chain_command_block{Command:"deeper_dark.near_portal"}
execute at @a[scores={deeper_dark.near_portal=1}] run particle minecraft:sculk_soul ~ ~ ~ 2 2 2 0 5 force
execute at @a[scores={deeper_dark.near_portal=1}] run playsound minecraft:block.sculk_catalyst.bloom ambient @a ~ ~ ~ .75 0

scoreboard players reset * deeper_dark.near_portal



#warden
execute as @e[type=minecraft:warden,predicate=deeper_dark:in_deeper_dark] at @s unless entity @a[gamemode=!spectator,distance=0..,nbt=!{Health:0f}] run data remove entity @s Brain.memories.minecraft:dig_cooldown
effect give @e[type=minecraft:warden,predicate=deeper_dark:in_deeper_dark] minecraft:resistance 1 0 true


#other
execute as @a[nbt={Inventory:[{}],Health:0f},predicate=deeper_dark:in_deeper_dark] at @s run function deeper_dark:drop
execute as @a[nbt={ActiveEffects:[{Id:28,Amplifier:-18b}]},predicate=deeper_dark:in_deeper_dark] at @s unless block ~ ~-.01 ~ air run effect clear @s slow_falling
execute as @a[predicate=minecraft:in_overworld,nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b,tag:{DeeperDarkKey:1b}}},tag=!deeper_dark.tp_cooldown] at @s run playsound minecraft:block.grindstone.use ambient @a ~ ~ ~ 1 0
item replace entity @a[predicate=minecraft:in_overworld,nbt={SelectedItem:{id:"minecraft:echo_shard",Count:1b,tag:{DeeperDarkKey:1b}}},tag=!deeper_dark.tp_cooldown] weapon.mainhand with minecraft:echo_shard